byte encoderLeftCycle;          //encoder section
byte encoderLeftCycleLast;
long encoderLeftCount;
long encoderLeftCountLast;
byte encoderRghtCycle;
byte encoderRghtCycleLast;
long encoderRghtCount;
long encoderRghtCountLast;
double encoderLeftVel=0;
float encoderRghtVel=0;
#define MavgSize 15             //How many averages to take (1 occurs every encoderVelTimestep) to filter velocity
int encoderMavgLeft[MavgSize];
int encoderMavgRght[MavgSize];
unsigned long encoderVelTimeout;
#define encoderVelTimestep 5    //how often to resolve velocity (milliseconds)
#define encoderScale 13.7789151473 //scales raw encoder from counts/millisecond to ... rad/sec
int MavgCycle=0;

int ledBlinkrate=1000;

bool motorsEnabled;
int motorLeftPwr;
int motorRghtPwr;
#define     hDisablePin 18  //h-bridge  controller disable pin
#define parkingBrakePin 19  //relay that releases brake and applys power to motor (high=active)
#define   rightEnableHI 20  
#define    leftEnableHI 21
#define        rightALI 12 //PWM
#define        rightBLI 13 //PWM
#define         leftALI 14 //PWM
#define         leftBLI 15 //PWM

float speedMax=500;
float speedAccel=100;
float speedDecel=100;
float speedCutoff=0.2;
double speedLeftInput;
float speedRghtInput;
float speedLeftOutput;
float speedRghtOutput;
unsigned long speedrampTimeout;
#define speedrampTimestep 5

#include <PID_v1.h>
double Kp=1, Ki=0, Kd=0;
double Lprtest;
PID myPID(&encoderLeftVel, &Lprtest, &speedLeftInput, Kp, Ki, Kd, DIRECT);


void setup(){
  pinMode(0, OUTPUT);
  pinMode(hDisablePin,     OUTPUT); digitalWrite(hDisablePin,     1);
  pinMode(parkingBrakePin, OUTPUT); digitalWrite(parkingBrakePin, 0);
  pinMode(leftEnableHI,    OUTPUT); digitalWrite(leftEnableHI,    0);
  pinMode(rightEnableHI,   OUTPUT); digitalWrite(rightEnableHI,   0);
  pinMode(leftALI,         OUTPUT); digitalWrite(leftALI,         0);
  pinMode(rightALI,        OUTPUT); digitalWrite(rightALI,        0);
  pinMode(leftBLI,         OUTPUT); digitalWrite(leftBLI,         0);
  pinMode(rightBLI,        OUTPUT); digitalWrite(rightBLI,        0);
  Serial.begin(115200);
  encoderInit();
}

void loop(){
  serialControl();
  uUpdate();
  if(millis()%50==0){
    //Serial.print(encoderLeftCount/456.0, 2); Serial.print('\t');
    Serial.print(encoderLeftVel, 2); Serial.print('\t');
    Serial.print(speedLeftInput, 2); Serial.print('\t');
    Serial.print(speedLeftOutput, 2); Serial.print('\t');
    Serial.print(motorsEnabled); Serial.print('\t');
    Serial.print(motorLeftPwr); Serial.print('\n');
  }
}

void uUpdate(){
  encoderUpdate();
  updateSpeedramps();
  myPID.Compute();
  if(motorsEnabled){motorsPower(Lprtest,0);}
  if(ledBlinkrate==0){PORTB &= ~(1<<PB0);}else if(ledBlinkrate<0){PORTB |= (1<<PB0);}else{if(millis()%(2*ledBlinkrate)>ledBlinkrate){PORTB |= (1<<PB0);}else{PORTB &= ~(1<<PB0);}}
}

void uDelay(unsigned long ms){ //delay and update critical functions at the same time
  unsigned long start = millis();
  do{ uUpdate(); }while(millis() - start < ms);
}
