/*
byte encoderLeftCycle;
byte encoderLeftCycleLast;
long encoderLeftCount;
long encoderLeftCountLast;
byte encoderRghtCycle;
byte encoderRghtCycleLast;
long encoderRghtCount;
long encoderRghtCountLast;
float encoderLeftVel=0;
float encoderRghtVel=0;
#define MavgSize 50
int encoderMavgLeft[MavgSize];
int encoderMavgRght[MavgSize];
unsigned long encoderVelTimeout;
#define encoderVelTimestep 2
int MavgCycle=0;
*/

void encoderInit(){
  cli();              //set up encoder interrupts on A1-A4
  PCICR |= 0b00000001;
  PCMSK0 |= 0b00011110;
  sei();
}

ISR(PCINT0_vect){  //encoder interrupt
  encoderLeftCycle = (PINA & 0b00000110)>>1;
  encoderRghtCycle = (PINA & 0b00011000)>>3;
  
  switch(encoderLeftCycle){case 2: encoderLeftCycle=3; break; case 3: encoderLeftCycle=2; break;} //cycle is now 0-1-2-3
  switch(encoderRghtCycle){case 2: encoderRghtCycle=3; break; case 3: encoderRghtCycle=2; break;} 

  if(encoderLeftCycle!=encoderLeftCycleLast){
    if(encoderLeftCycleLast==3&&encoderLeftCycle==0){encoderLeftCount--;
    }else if(encoderLeftCycleLast==0&&encoderLeftCycle==3){encoderLeftCount++; 
    }else if(encoderLeftCycleLast<encoderLeftCycle){encoderLeftCount--;
    }else{encoderLeftCount++;
    }
    encoderLeftCycleLast=encoderLeftCycle;
  } 
  if(encoderRghtCycle!=encoderRghtCycleLast){
    if(encoderRghtCycleLast==3&&encoderRghtCycle==0){encoderRghtCount++;
    }else if(encoderRghtCycleLast==0&&encoderRghtCycle==3){encoderRghtCount--; 
    }else if(encoderRghtCycleLast<encoderRghtCycle){encoderRghtCount++;
    }else{encoderRghtCount--;
    }
    encoderRghtCycleLast=encoderRghtCycle;
  }
}

void encoderUpdate(){ //calculates encoder ang. velocity and filters it with moving average
  if(millis()-encoderVelTimeout>=encoderVelTimestep){
    encoderVelTimeout=millis();
    MavgCycle++;
    if(MavgCycle>=MavgSize-1){MavgCycle=0;}
    encoderMavgLeft[MavgCycle]=encoderLeftCount-encoderLeftCountLast;
    encoderLeftCountLast=encoderLeftCount;
    encoderMavgRght[MavgCycle]=encoderRghtCount-encoderRghtCountLast;
    encoderRghtCountLast=encoderRghtCount;
    int tdiffLeft = 0;
    int tdiffRght = 0;
    for(int j=0; j<=MavgSize-1; j++){
      tdiffLeft+=encoderMavgLeft[j];
      tdiffRght+=encoderMavgRght[j];
    }
    encoderLeftVel=(encoderScale)*tdiffLeft/(MavgSize*encoderVelTimestep);
    encoderRghtVel=(encoderScale)*tdiffRght/(MavgSize*encoderVelTimestep);
  }
}
