byte encoderLeftCycle;          //encoder section
byte encoderLeftCycleLast;
long encoderLeftCount;
long encoderLeftCountLast;
byte encoderRghtCycle;
byte encoderRghtCycleLast;
long encoderRghtCount;
long encoderRghtCountLast;
int tdiffLeft = 0;
int tdiffRght = 0;
double encoderLeftVel=0;
double encoderRghtVel=0;
unsigned int MavgSize=100;             //How many averages to take (1 occurs every encoderVelTimestep) to filter velocity
int encoderMavgLeft[255];
int encoderMavgRght[255];
unsigned long encoderVelTimeout;
unsigned int encoderVelTimestep=1;    //how often to resolve velocity (microseconds)
#define encoderScale 21.9298245 //scales raw encoder from counts/microsecond to 10*rev/sec
int MavgCycle=0;

int ledBlinkrate=1000;

bool motorsEnabled;
int motorLeftPwr;
int motorRghtPwr;
#define     hDisablePin 18  //h-bridge  controller disable pin
#define parkingBrakePin 19  //relay that releases brake and applys power to motor (high=active)
#define   rightEnableHI 20  
#define    leftEnableHI 21
#define        rightALI 14 //PWM
#define        rightBLI 15 //PWM
#define         leftALI 12 //PWM
#define         leftBLI 13 //PWM

float speedMax=40;
float speedAccel=20;
float speedDecel=20;
float speedCutoff=0.2;
double speedLeftInput;
double speedRghtInput;
double speedLeftOutput;
double speedRghtOutput;
unsigned long speedrampTimeout;
double speedLeftPower;
double speedRghtPower;
#define speedrampTimestep 5
#include <PID_v1.h>
double speedKp=0, speedKi=70, speedKd=0; //PID Gains
bool usePIDs=0;
bool usingPIDs=0;
PID speedLeftPID(&encoderLeftVel, &speedLeftPower, &speedLeftOutput, speedKp, speedKi, speedKd, DIRECT);
PID speedRghtPID(&encoderRghtVel, &speedRghtPower, &speedRghtOutput, speedKp, speedKi, speedKd, DIRECT);
#define speedPIDSampletime 50

bool isStopped=1;
#define stopTimeout 2000 //after this many millis of low enough speed and power, stop using the PID controllers, turn off and brake the motors
unsigned long stopTimeoutTimer=0;
float encoderStopVel=0.5; //motors are "stopped" when both encoder and commanded abs speeds are less than this value
int speedStopPower=6;     //motors are "stopped" when both left and right abs power are less than this value

void setup(){
  pinMode(0, OUTPUT);
  motorsInit();
  Serial.begin(115200);
  Serial1.begin(115200);
  Serial1.print(F("Ready\r\n>"));
  encoderInit();
  speedLeftPID.SetSampleTime(speedPIDSampletime); 
  speedRghtPID.SetSampleTime(speedPIDSampletime);
  speedLeftPID.SetTunings(speedKp, speedKi, speedKd);
  speedRghtPID.SetTunings(speedKp, speedKi, speedKd);
  speedLeftPID.SetOutputLimits(-255,255);
  speedRghtPID.SetOutputLimits(-255,255);
  speedLeftPID.SetMode(AUTOMATIC);
  speedRghtPID.SetMode(AUTOMATIC);
}

void loop(){
  serialControl();
  uUpdate();
  
  if((abs(speedLeftOutput)>speedCutoff||abs(speedRghtOutput>speedCutoff))&&isStopped==1){ //if speed is called for and are stopped, unlock and enable motors and PIDs
    motorsEnable();
    usingPIDs=1;
    isStopped=0;
    stopTimeoutTimer=millis();
    ledBlinkrate=-1;
    Serial1.print(F("autostop OFF\r\n"));
  }
  
  if(isStopped==0){
    if(millis()-stopTimeoutTimer>=stopTimeout){ //we know we should execute stop commands here
      usingPIDs=0;
      motorsDisable();
      isStopped=1;
      ledBlinkrate=400;
      Serial1.print(F("autostop ON\r\n"));
    }
    if(!(abs(encoderLeftVel)<=encoderStopVel&&abs(encoderRghtVel)<=encoderStopVel&&abs(speedLeftPower)<=speedStopPower&&abs(speedRghtPower)<=speedStopPower&&abs(speedLeftOutput)<=encoderStopVel&&abs(speedRghtOutput)<=encoderStopVel)){
      stopTimeoutTimer=millis(); //stop conditions not met, so don't stop
    }
  }
  
  if(millis()%10==0){
    //Serial.print(encoderLeftCount/456.0, 2); Serial.print('\t');
    //Serial.print(tdiffLeft); Serial.print('\t');
    Serial.print(encoderLeftVel, 2); Serial.print('\t');
    Serial.print(speedLeftInput, 2); Serial.print('\t');
    Serial.print(speedLeftOutput, 2); Serial.print('\t');
    Serial.print(speedLeftPower/10, 2); Serial.print('\t');
    //Serial.print(motorsEnabled); Serial.print('\n');
    //Serial.print(motorLeftPwr); Serial.print('\n');
    Serial.println();
  }
}

void uUpdate(){
  encoderUpdate();
  updateSpeedramps();
  if(usingPIDs){
    speedLeftPID.Compute();
    speedRghtPID.Compute();
    if(speedLeftOutput==0&&abs(encoderLeftVel)<=speedCutoff){ //turn off motor power if speed actually zero (anti winddown)
      speedLeftPID.SetOutputLimits(0.0, 1.0);  
      speedLeftPID.SetOutputLimits(-1.0, 0.0); 
      speedLeftPID.SetOutputLimits(-255,255);
    }
    if(speedRghtOutput==0&&abs(encoderRghtVel)<=speedCutoff){
      speedRghtPID.SetOutputLimits(0.0, 1.0);  
      speedRghtPID.SetOutputLimits(-1.0, 0.0); 
      speedRghtPID.SetOutputLimits(-255,255);
    }
    motorsPower(speedLeftPower, speedRghtPower);
  }
  if(ledBlinkrate==0){PORTB &= ~(1<<PB0);}else if(ledBlinkrate<0){PORTB |= (1<<PB0);}else{if(millis()%(2*ledBlinkrate)>ledBlinkrate){PORTB |= (1<<PB0);}else{PORTB &= ~(1<<PB0);}}
}

void uDelay(unsigned long ms){ //delay and update critical functions at the same time
  unsigned long start = millis();
  do{ uUpdate(); }while(millis() - start < ms);
}
