void motorsInit(){
  pinMode(hDisablePin,     OUTPUT); digitalWrite(hDisablePin,     1);
  pinMode(parkingBrakePin, OUTPUT); digitalWrite(parkingBrakePin, 0);
  pinMode(leftEnableHI,    OUTPUT); digitalWrite(leftEnableHI,    0);
  pinMode(rightEnableHI,   OUTPUT); digitalWrite(rightEnableHI,   0);
  pinMode(leftALI,         OUTPUT); digitalWrite(leftALI,         0);
  pinMode(rightALI,        OUTPUT); digitalWrite(rightALI,        0);
  pinMode(leftBLI,         OUTPUT); digitalWrite(leftBLI,         0);
  pinMode(rightBLI,        OUTPUT); digitalWrite(rightBLI,        0);
}

void motorsEnable(){
  if(motorsEnabled==1){return;}   //don't run if motors are already enabled (might be under power!)
  digitalWrite(hDisablePin,   1); //set everything to inital off (disabled) values
  digitalWrite(leftEnableHI,  0); 
  digitalWrite(rightEnableHI, 0);
  digitalWrite(leftALI,       0);
  digitalWrite(rightALI,      0);
  digitalWrite(leftBLI,       0);
  digitalWrite(rightBLI,      0);
  
  digitalWrite(parkingBrakePin, 1); //turn on main power relay
  uDelay(100);
  
  digitalWrite(hDisablePin,   0); //enable hbridges
  digitalWrite(leftEnableHI,  1); //enable left motor
  digitalWrite(rightEnableHI, 1); //enable right motor
  motorsEnabled=1;
}

void motorsDisable(){
  motorsPower(0,0);
  digitalWrite(hDisablePin,   1);   //disable hbridges
  digitalWrite(parkingBrakePin, 0); //turn off power
  uDelay(100);
  
  digitalWrite(hDisablePin,   1); //set everything to inital off (disabled) values
  digitalWrite(leftEnableHI,  0); 
  digitalWrite(rightEnableHI, 0);
  digitalWrite(leftALI,       0);
  digitalWrite(rightALI,      0);
  digitalWrite(leftBLI,       0);
  digitalWrite(rightBLI,      0);
  
  motorsEnabled=0;
}

void motorsPower(int leftpwr, int rightpwr){
  if(motorsEnabled!=1){return;}  //never run without enabling motor
  
  leftpwr =constrain( leftpwr, -255,255);
  rightpwr=constrain(rightpwr, -255,255);
  if(motorLeftPwr==leftpwr&&motorRghtPwr==rightpwr){return;}

  digitalWrite(hDisablePin,   1); //disable the h bridges while changing settings
   
  if(leftpwr <0){ analogWrite(leftALI ,abs(leftpwr ));  analogWrite(leftBLI ,0);             }
    if(leftpwr >0){ analogWrite(leftALI ,0);            analogWrite(leftBLI ,abs(leftpwr));  }
  if(rightpwr<0){ analogWrite(rightALI,abs(rightpwr));  analogWrite(rightBLI,0);             }
    if(rightpwr>0){ analogWrite(rightALI,0);            analogWrite(rightBLI,abs(rightpwr)); }
  
  if(leftpwr ==0){ analogWrite(leftALI ,0);             analogWrite(leftBLI ,0);             }
  if(rightpwr==0){ analogWrite(rightALI,0);             analogWrite(rightBLI,0);             }
  
  digitalWrite(hDisablePin,   0); //re-enable h bridge
  motorLeftPwr=leftpwr; motorRghtPwr=rightpwr;
}
