#include <string.h>
#include <stdlib.h>
#define serbuflen 50 //total length of single line of input 
#define nounnum 3  //number of nouns (parameters)

char serbuf[serbuflen+1];   //buffer for storing Serial1 input text
char* verb;                 //stores command text
char* noun[nounnum]; //stores pointers to parameters
byte nouns;
const char delim[2] = " ";

void serialControl(){
  if(!Serial1.available()){return;}
  byte slen=0;
  bool getline=1;
  bool ok=0;                          //checks if is bad command or not
  while(getline){
    if(Serial1.available()){
      serbuf[slen] = Serial1.read();
      if(serbuf[slen]==13){getline=0;}
      if(serbuf[slen]==8){slen-=2;if(slen==254){slen++;}else{
        //Serial1.write(8);Serial1.write(32);Serial1.write(8);
      }}else{
          //Serial1.write(serbuf[slen]); //echo
      } 
      //Serial1.print(slen);Serial1.print('\t');Serial1.write(ubuf[slen]);Serial1.print('\t');Serial1.println(ubuf[slen]); //echo
      slen++;
    }
  }
  slen--;                             //remove last character (CR) and replace with string terminator
  serbuf[slen]='\0';                  //terminate the Serial1 buffer string
     
  verb=strtok(serbuf, delim);
  if(verb == NULL){ ok=1; }           //no command, just reprint > prompt
  nouns = 0;                          //seperate nouns
  char* nountemp;
  nountemp=strtok(NULL, delim);
  while(nountemp != NULL ){
      noun[nouns]=nountemp;
      nouns++;
      nountemp = strtok(NULL, delim);
      if(nouns>=nounnum-1){nouns=nounnum-1;}
  }
  char* pend;                         //used in strtol, normally not used.
  //Serial1.print(F("\r\n")); //echo
  
  //******************************************************************************************************************************
  
  if(0==strcmp_P(verb,PSTR("blink"))){
    ledBlinkrate=strtol(noun[0], &pend, 10);
  }
  if(0==strcmp_P(verb,PSTR("s"))){
    speedLeftInput=strtod(noun[0], &pend);
    speedRghtInput=strtod(noun[1], &pend);
    Serial1.print(F("Speed input: "));Serial1.print(speedLeftInput);Serial1.print(F("\t"));Serial1.print(speedRghtInput);Serial1.print(F("\r\n"));
  }
  if(0==strcmp_P(verb,PSTR("en"))){
    motorsEnable();
    Serial1.print(F("Motors Enabled\r\n"));
  }
  if(0==strcmp_P(verb,PSTR("dn"))){
    motorsDisable();
    Serial1.print(F("Motors Disabled\r\n"));
  }
  if(0==strcmp_P(verb,PSTR("m"))){
    motorsPower(strtol(noun[0], &pend, 10),strtol(noun[1], &pend, 10));
    Serial1.print(F("Motor power: "));Serial1.print(motorLeftPwr);Serial1.print(F("\t"));Serial1.print(motorRghtPwr);Serial1.print(F("\r\n"));
  }

  if(0==strcmp_P(verb,PSTR("p"))){
     speedKp=strtod(noun[0], &pend);
     resetPIDs();
  }
  if(0==strcmp_P(verb,PSTR("i"))){
     speedKi=strtod(noun[0], &pend);
     resetPIDs();
  }
  if(0==strcmp_P(verb,PSTR("d"))){
     speedKd=strtod(noun[0], &pend);
     resetPIDs();
  }

  if(0==strcmp_P(verb,PSTR("f"))){
     MavgSize=strtol(noun[0], &pend, 10);
     encoderVelTimestep=strtol(noun[1], &pend, 10);
     resetPIDs();
     Serial1.print(F("encoder speed filter: "));Serial1.print(encoderVelTimestep);Serial1.print(F("ms, "));Serial1.print(MavgSize);Serial1.print(F("bins\r\n"));
  }
  
  Serial1.print(F(">"));
}

void resetPIDs(){
  speedLeftPID.SetTunings(speedKp, speedKi, speedKd);
  speedRghtPID.SetTunings(speedKp, speedKi, speedKd);
   
  speedLeftPID.SetOutputLimits(0.0, 1.0);  
  speedLeftPID.SetOutputLimits(-1.0, 0.0); 
  speedLeftPID.SetOutputLimits(-255,255);
  
  speedRghtPID.SetOutputLimits(0.0, 1.0);  
  speedRghtPID.SetOutputLimits(-1.0, 0.0); 
  speedRghtPID.SetOutputLimits(-255,255);
  
  speedLeftPID.SetMode(AUTOMATIC);
  speedRghtPID.SetMode(AUTOMATIC);
  Serial1.print(F("PID: "));Serial1.print(speedKp);Serial1.print(' ');Serial1.print(speedKi);Serial1.print(' ');Serial1.print(speedKd);Serial1.print(F("\r\n"));
}
