#define lockPin 13

int stickForwardMin = 520;
int stickForwardMax = 815;
int stickReverseMin = 175;
int stickReverseMax = 480;

int stickLeftMin = 520;
int stickLeftMax = 840;
int stickRightMin = 160;
int stickRightMax = 480;

int stickfb = 0;
int sticklr = 0;

int leftfb =0;
int rightfb = 0;
int leftlr = 0;
int rightlr = 0;

int leftPwm = 0;
int rightPwm = 0;


byte stopFlag = 0;  //if zero, unit should stop.
byte stopState = 0; //state of stop relay: 0 = off (stopped) 
unsigned long lastNonzeroTime = 0; //Last time that motion was desired on joystick
unsigned long millisToLock = 1000; //Time to wait before parking brake on


void setup() {
  Serial.begin(115200);
  pinMode(lockPin, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
}

void loop() {
  int ba7 = analogRead(A7);
  int ba6 = analogRead(A6);
  
  if(stopFlag > 0){
    lastNonzeroTime = millis() + millisToLock;
    if(stopState == 0){stopState = 1; digitalWrite(lockPin, HIGH); delay(100);}
  }
  if(millis() >= lastNonzeroTime){
    if(stopState == 1){stopState = 0; delay(100); digitalWrite(lockPin, LOW);}
  }
  
  if(ba6 > stickForwardMin){
    bitWrite(stopFlag, 0, 1);
    bitWrite(stopFlag, 1, 0);
    Serial.print(F("FWD, "));
    stickfb = map(ba6, stickForwardMin, stickForwardMax, 0, 255);
    if(stickfb>255){stickfb = 255;}
    Serial.println(stickfb, DEC);
  }
  if(ba6 < stickReverseMax){
    bitWrite(stopFlag, 0, 0);
    bitWrite(stopFlag, 1, 1);
    Serial.print(F("REV, "));
    stickfb = -map(ba6, stickReverseMax, stickReverseMin, 0, 255);
    if(stickfb<-255){stickfb = -255;}
    Serial.println(stickfb, DEC);
  }
  if(ba6 >= stickReverseMax && ba6 <= stickForwardMin){
    bitWrite(stopFlag, 0, 0);
    bitWrite(stopFlag, 1, 0);
    stickfb = 0;
    Serial.println(F("STP"));
  }
  
  if(ba7 > stickLeftMin){
    bitWrite(stopFlag, 2, 1);
    bitWrite(stopFlag, 3, 0);
    Serial.print(F("LFT, "));
    sticklr = -map(ba7, stickLeftMin, stickLeftMax, 0, 255);
    if(sticklr>255){sticklr = 255;}
    Serial.println(sticklr, DEC);
  }
  if(ba7 < stickRightMax){
    bitWrite(stopFlag, 2, 0);
    bitWrite(stopFlag, 3, 1);
    Serial.print(F("RGT, "));
    sticklr = map(ba7, stickRightMax, stickRightMin, 0, 255);
    if(sticklr<-255){sticklr = -255;}
    Serial.println(sticklr, DEC);
  }
  if(ba7 >= stickRightMax && ba7 <= stickLeftMin){
    bitWrite(stopFlag, 2, 0);
    bitWrite(stopFlag, 3, 0);
    sticklr = 0;
    Serial.println(F("STP"));
  } 

  leftfb = stickfb;
  rightfb = stickfb;

  leftlr = sticklr;
  rightlr = -sticklr;

  leftPwm = (leftfb+leftlr/1.5);
  rightPwm = (rightfb+rightlr/1.5);

  if(leftPwm>255){leftPwm = 255;}
  if(leftPwm<-255){leftPwm = -255;}
  if(rightPwm>255){rightPwm = 255;}
  if(rightPwm<-255){rightPwm = -255;}

  if(leftPwm>0){
    digitalWrite(3, HIGH);
    digitalWrite(4, LOW);
    analogWrite(5, abs(leftPwm));
  }
  if(leftPwm<0){
    digitalWrite(3, LOW);
    digitalWrite(4, HIGH);
    analogWrite(5, abs(leftPwm));
  }
  if(leftPwm=0){
    digitalWrite(3, LOW);
    digitalWrite(4, LOW);
    analogWrite(5, abs(leftPwm));
  }
  if(rightPwm>0){
    digitalWrite(7, HIGH);
    digitalWrite(8, LOW);
    analogWrite(6, abs(rightPwm));
  }
  if(rightPwm<0){
    digitalWrite(7, LOW);
    digitalWrite(8, HIGH);
    analogWrite(6, abs(rightPwm));
  }
  if(rightPwm=0){
    digitalWrite(7, LOW);
    digitalWrite(8, LOW);
    analogWrite(6, abs(rightPwm));
  }


  if(stopFlag == 0){
    digitalWrite(3, LOW);
    digitalWrite(7, LOW);
    digitalWrite(4, LOW);
    digitalWrite(8, LOW);
    analogWrite(5, 0);
    analogWrite(6, 0);
  }

  Serial.println(leftPwm, DEC);
  Serial.println(rightPwm, DEC);
  Serial.println(stopFlag, DEC);
  Serial.println();
  delay(20);
}
